var driveDivisorBar = new Array();
var driveTotal = new Array();
var drives;
var drivesCount;

var skin = "";
var colorGraph = "";
var colorGraphBack = "";
var colorText = "";
var colorAlert = "";

window.attachEvent("onload", pageLoad);

System.Gadget.settingsUI = "settings.html";
System.Gadget.onSettingsClosed = settingsClosed;

function settingsClosed() 
{
  loadSettings();
  updateGadget();
  refreshGadget();
}

function loadSettings()
{
  skin = System.Gadget.Settings.readString("skin");
  colorGraph = System.Gadget.Settings.readString("colorGraph");
  colorGraphBack = System.Gadget.Settings.readString("colorGraphBack");
  colorText = System.Gadget.Settings.readString("colorText");
  colorAlert = System.Gadget.Settings.readString("colorAlert");
  if (skin.length==0) skin="blue";
  if (colorGraph.length==0) colorGraph="C4E1FF";
  if (colorGraphBack.length==0) colorGraphBack="3399FF";
  if (colorText.length==0) colorText="FFFFFF";
  if (colorAlert.length==0) colorAlert="B22222";
  var drvs = System.Gadget.Settings.readString("drives");
  if (drvs.length== 0) drvs = "C";
  var length = drvs.length;
  drives = "";
  for (var i = 0; i < length; i++)
  {
    var chr = drvs.charAt(i);
    if (System.Shell.drive(chr).isReady)
      drives += chr;
  }
  drivesCount = drives.length;
}

function updateGadget()
{
  setGadget();
}

function pageLoad()
{
  window.detachEvent("onload", pageLoad);
  window.attachEvent("onunload", pageUnload);
  loadSettings();
  setGadget();
  runGadget();
}

function pageUnload()
{
  window.detachEvent("onunload", pageUnload);
  System.Gadget.Settings.writeString("skin", skin);
  System.Gadget.Settings.writeString("colorGraph", colorGraph);
  System.Gadget.Settings.writeString("colorGraphBack", colorGraphBack);
  System.Gadget.Settings.writeString("colorText", colorText);
  System.Gadget.Settings.writeString("colorAlert", colorAlert);
  System.Gadget.Settings.writeString("drives", drives);
}

function setGadget()
{
  driveBody.style.height = (18 + drivesCount * 36) + "px";
  driveInfo.style.color = "#" + colorText;
  driveText.style.backgroundImage = "url(skins/" + skin + "/textBg.png)";
  
  var str = "";
  for (var drive = 0; drive < drivesCount; drive++)
    str += "<div id=\"drive" + drive + "\" class=\"graphbox\" style=\"background-image:url('skins/" + skin + "/graphBg.png');top:" + (18 + drive * 36) + "px;\"></div>";
  driveGraphs.innerHTML = str;
  var strRunText = "";
  for (var drive = 0; drive < drivesCount; drive++)
  {
    var chr = drives.charAt(drive);
    var cDrive = System.Shell.drive(chr);
    driveTotal[drive] = parseInt(cDrive.totalSize);
    driveDivisorBar[drive] = 116 / driveTotal[drive];
    var obj = document.getElementById("drive" + drive);
    obj.style.display = "block";
    var str = "";
    str += "<div id=\"driveName" + drive + "\" class=\"infotextleft\" style=\"top:0px;\">" + cDrive.volumeLabel + " (" + chr + ":) [" + cDrive.driveFormat + "]</div>";
    str += "<div id=\"driveUs" + drive + "\" class=\"infotextleft\" style=\"top:22px;\"></div>";
    str += "<div id=\"driveFr" + drive + "\" class=\"infotextright\" style=\"top:22px;\"></div>";
    str += "<div id=\"driveBarBack" + drive + "\" class=\"barback\" style=\"background-color:#" + colorGraphBack + ";\"></div>";
    str += "<div id=\"driveBarFront" + drive + "\" class=\"barfront\" style=\"background-color:#" + colorGraph + ";\"></div>";
    obj.innerHTML = str;
    strRunText += chr + ":" + numFormat(driveTotal[drive]) + " ";
  }
  runText.innerText = strRunText;
}

function runGadget()
{
  runProgress();
}

function runProgress()
{
  refreshGadget();
  gadgetTimeOut = setTimeout("runProgress()", 10000);
}

function refreshGadget()
{
  for (var drive = 0; drive < drivesCount; drive++)
    setdrive(drive);
}

function setdrive(drive)
{
  var cDrive = System.Shell.drive(drives.charAt(drive));
  var driveFree = parseInt(cDrive.freeSpace);
  var driveUsed = driveTotal[drive] - driveFree;
  var bWidth = Math.round(driveUsed * driveDivisorBar[drive]);
  if (bWidth > 116) bWidth = 116;
  var obj = document.getElementById("driveBarFront" + drive);
  obj.style.width = bWidth + "px";
  obj.style.backgroundColor = "#" + ((driveUsed / driveTotal[drive]) < 0.95 ? colorGraph : colorAlert);
  document.getElementById("driveUs" + drive).innerText = numFormat(driveUsed);
  document.getElementById("driveFr" + drive).innerText = numFormat(driveFree);
}

function numFormat(value)
{
  if (value < 1000) return (value + "Mb");
  if (value < 10240) return ((Math.round(value / 10.24) / 100) + "Gb");
  if (value < 102400) return ((Math.round(value / 102.4) / 10) + "Gb");
  if (value < 1024000) return (Math.round(value / 1024) + "Gb");
  if (value < 10485760) return ((Math.round(value / 10485.76) / 100) + "Tb");
}
